{ config, lib, pkgs, ... }:

{
  imports = [
    ./common.nix
  ];

  services.printing.enable = true;
  services.openssh.startWhenNeeded = true;

  sound.enable = true;
  hardware.pulseaudio.enable = false;
  security.rtkit.enable = true;
  services.pipewire = {
    enable = true;
    alsa.enable = true;
    alsa.support32Bit = true;
    pulse.enable = true;
  };

  fileSystems."/mnt/library" = {
    device = "library.mesh.vimium.net:/mnt/library";
    fsType = "nfs";
    options = [ "nfsvers=4.2" "soft" "nocto" "ro" "x-systemd.automount" "noauto" ];
  };

  system.autoUpgrade = {
    enable = true;
    flake = "git+ssh://git@git.vimium.com/jordan/nix-config.git";
    randomizedDelaySec = "10min";
  };

  modules = {
    desktop.gnome.enable = true;
    networking.tailscale.enable = true;
  };
}
