{ config, lib, pkgs, ... }:

let cfg = config.modules.desktop.gaming.lutris;
in {
  options.modules.desktop.gaming.lutris = {
    enable = lib.mkOption {
      default = false;
      example = true;
    };
  };

  config = lib.mkIf cfg.enable {
    user.packages = with pkgs; [
      lutris
      vulkan-loader
      vulkan-tools
    ];

    hardware.opengl = {
      enable = true;
      driSupport = true;
      driSupport32Bit = true;
    };
  };
}
