{ config, lib, pkgs, ... }:

let cfg = config.modules.desktop.media.recording;
in {
  options.modules.desktop.media.recording = {
    audio.enable = lib.mkOption {
      default = false;
      example = true;
    };
    video.enable = lib.mkOption {
      default = false;
      example = true;
    };
  };

  config = {
    user.packages = with pkgs;
      (if cfg.audio.enable then [
        ardour
        audacity
      ] else []) ++
      (if cfg.video.enable then [
        handbrake
        mkvtoolnix
        obs-studio
      ] else []);
  };
}
