{ config, lib, pkgs, ... }:

let cfg = config.modules.security.gpg;
in {
  options.modules.security.gpg = {
    enable = lib.mkOption {
      default = false;
      example = true;
    };
  };

  config = lib.mkIf cfg.enable {
    home.programs.gpg = {
      enable = true;
    };

    home.services.gpg-agent = {
      enable = true;
      enableSshSupport = true;
    };
  };
}
